<?xml version="1.0" encoding="UTF-8"?>
<!--
  ~ Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" >
    <!-- Template for configuring module parameters-->
    <xsl:output method="html"/>

    <xsl:template match="ns1:getModuleParametersResponse" xmlns:ns1="http://org.apache.axis2/xsd">
        <fieldset style="border:none;">
            <div id="configureModuleHeader"></div>

        <xsl:choose>
            <xsl:when test="return">
                <div id="moduleConfigUpdate"></div>

                <!-- Div handling starts from here-->
                <div id="formset">
                    <form>
                        <fieldset>
                            <legend>Edit module specific parameters</legend>
                            <xsl:for-each select="return">
								<xsl:if test="parameter/@name!=''">
                                <div style="clear: both;">
                                    <label style="width:25%;"><xsl:value-of select="parameter/@name"/></label>
                                    <input type="text">
                                            <xsl:attribute name="size">50</xsl:attribute>
                                            <xsl:attribute name="value"><xsl:value-of select="parameter"/></xsl:attribute>
                                            <xsl:attribute name="id"><xsl:value-of select="generate-id()"/></xsl:attribute>
                                            <xsl:attribute name="tabindex">
                                                <xsl:value-of select="position()"/>
                                            </xsl:attribute>
                                            <xsl:if test="@locked='true'">
                                                <xsl:attribute name="disabled">true</xsl:attribute>
                                            </xsl:if>
                                    </input>                                

                                    <nobr>
                                        &#160;&#160;
                                        <a href="#" >
                                            <xsl:attribute name="class">remove_param</xsl:attribute>
                                            <xsl:attribute name="id"><xsl:value-of select="parameter/@name"/></xsl:attribute>
                                            <xsl:attribute name="onClick">javascript:removeModuleParameter(this);return false;</xsl:attribute>
                                            <xsl:attribute name="title">Remove Module Parameter</xsl:attribute>
                                            <xsl:attribute name="alt">Remove</xsl:attribute>
                                            &#160;&#160;&#160;&#160;
                                        </a>
                                    </nobr>
                                    </div>
								</xsl:if>
							</xsl:for-each>
                            <p>&#160;</p>
                            <div class="buttonrow">
                                <!-- update button -->
                                <input type="button" value="update">
                                    <xsl:attribute name="onClick">javascript:
                                        var arrayOfNames=new Array();
                                        var arrayOfValues=new Array();
                                        <xsl:for-each select="return">
                                            arrayOfNames[<xsl:value-of select="position()-1"/>] = '<xsl:value-of select="parameter/@name"/>';
                                            arrayOfValues[<xsl:value-of select="position()-1"/>] = (document.getElementById('<xsl:value-of select="generate-id()"/>').value);
                                        </xsl:for-each>
                                        processModuleConfigUpdate(arrayOfNames,arrayOfValues);
                                        return false;
                                    </xsl:attribute>
                                </input>
                                <input type="button" value="add">
                                    <xsl:attribute name="onClick">javascript:addModuleParameter();return false;</xsl:attribute>
                                </input>
								<input type="button" onClick="javascript:history.back(); return false;" value="Cancel"/>
                            </div>

                        </fieldset>
                      </form>
                </div>
            </xsl:when>
            <xsl:otherwise>
                <div id="moduleConfigUpdate"></div>
                <!-- end of link header block -->
                <div id="formset">
                    <form>
                        <fieldset>
                            <legend>Parameters</legend>
                                <p>No Module parameters found.</p>
                                <div>
                                    <!-- add button -->
                                    <input type="button" value="add">
                                        <xsl:attribute name="onClick">javascript:addModuleParameter();return false;</xsl:attribute>
                                    </input>
                                </div>
                        </fieldset>
                    </form>
                </div>
            </xsl:otherwise>
        </xsl:choose>

        </fieldset>
    </xsl:template>
</xsl:stylesheet>
