<!--
  ~ Copyright 2005-2007 WSO2, Inc. (http://wso2.com)
  ~
  ~ Licensed under the Apache License, Version 2.0 (the "License");
  ~ you may not use this file except in compliance with the License.
  ~ You may obtain a copy of the License at
  ~
  ~ http://www.apache.org/licenses/LICENSE-2.0
  ~
  ~ Unless required by applicable law or agreed to in writing, software
  ~ distributed under the License is distributed on an "AS IS" BASIS,
  ~ WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
  ~ See the License for the specific language governing permissions and
  ~ limitations under the License.
  -->

<xsl:stylesheet version="1.0"
                xmlns:xsl="http://www.w3.org/1999/XSL/Transform">

    <xsl:template match="ns1:getTransportDetailsResponse" xmlns:ns1="http://org.apache.axis2/xsd">
    	<div id="formset">
            <xsl:choose>
                <xsl:when test="return">
                    <div>
                        <table class="styled">
                            <thead>
                                <tr>
                                    <th>Name</th>
                                    <th>Value</th>
                                </tr>
                            </thead>
                            <tbody>
                                <xsl:for-each select="return">
                                       <tr>
                                           <xsl:if test="position() mod 2 = 1">
                                               <xsl:attribute name="bgcolor">#EEEFFB</xsl:attribute>
                                           </xsl:if>
                                            <td>Active</td>
                                            <td><xsl:value-of select="active"/></td>
                                        </tr>
                                        <xsl:for-each select="parameters">
                                            <tr>
                                                <xsl:if test="position() mod 2 = 0">
                                                   <xsl:attribute name="bgcolor">#EEEFFB</xsl:attribute>
                                               </xsl:if>
                                                <td>
                                                    <xsl:value-of select="name"/>
                                                </td>
                                                <td>
                                                    <xsl:value-of select="value"/>
                                                </td>
                                            </tr>

                                        </xsl:for-each>

                                </xsl:for-each>
                            </tbody>
                        </table>
                    </div>
                </xsl:when>
                <xsl:otherwise>
                    <b>
                        <i>Transport Information is not available</i>
                    </b>
                </xsl:otherwise>

            </xsl:choose>
		</div>
    </xsl:template>
</xsl:stylesheet>